<script setup lang="ts">
import { storeToRefs } from 'pinia'
import type { Ref } from 'vue'
import { useUIStore } from '~/store/UI'

interface Props {
  tab: boolean
}

const { tab } = defineProps<Props>()
const portal = ref()
const ui = useUIStore()
const { width: windowWidth, height: windowHeight, fullView } = storeToRefs(ui)
const {
  x,
  y,
  width,
  height,
} = useElementBounding(portal)

const selectedTitle = inject('selectedTitle') as Ref<string>
// Generate a reactive style sheet from state

const style = computed(() => {
  return `
  .ReactModal__Content--after-open > #participant-window {
    display: ${(tab && selectedTitle.value === 'info' && !fullView.value) ? 'flex' : 'none'} !important;
    background-color: white;
    left: ${x.value - windowWidth.value / 2}px !important;
    top: ${y.value - windowHeight.value / 2}px !important;
    width: ${width.value}px !important;
    height: ${height.value}px !important;
    transform-origin: 0 0;
    transform: translate(0,0) !important;
    position: fixed !important;
  }`
})

useStyleTag(style)
</script>

<template>
  <div ref="portal" class="pointer-events-none" v-bind="$attrs" />
</template>

<style lang="scss">
.participants-item__avatar{

    font-size: 0px !important;
    position: relative;
    border-radius: 100%;
    background-color: #393939 !important;
    border: none !important;
    border-radius: 8px !important;

    &::after{
      content: '';
      --un-icon: url("data:image/svg+xml;utf8,%3Csvg viewBox='0 0 16 16' width='1.2em' height='1.2em' xmlns='http://www.w3.org/2000/svg' %3E%3Cpath fill='currentColor' d='M3 14s-1 0-1-1s1-4 6-4s6 3 6 4s-1 1-1 1H3Zm5-6a3 3 0 1 0 0-6a3 3 0 0 0 0 6Z'/%3E%3C/svg%3E");
      -webkit-mask: var(--un-icon) no-repeat;
      mask: var(--un-icon) no-repeat;
      mask-size: 100% 100%;
      -webkit-mask: var(--un-icon) no-repeat;
      -webkit-mask-size: 100% 100%;
      background-color: rgba(white, 60%) !important;
      width: 60%;
      height: 60%;
      position: absolute;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
    }
}

.ReactModalPortal {
  //hide avatar
  // .participants-item__avatar{
  //   display: none !important;
  // }
  //Box shadow
  .common-window{
    box-shadow: none !important;
  }
  .window-content{
    cursor: default !important;
  }
  #participant-window {
    color: white;
    border-color: #242424 !important;
    [role="rowgroup"] {
      //color: #111 !important;
      pointer-events: none !important;
      cursor: default !important;
    }

    >* {
      background-color: #242424 !important;
    }

    >.window-header {
      display: none;
    }

    >.window-content {
      >div:nth-child(1) {
        height: 100%;
        background-color: #242424 !important;

        >.participants-section
        -container {
          height: 100%;
          .participants-search-box__fake-box {
            display: none;
          }
        }
      }
    }

    .participants-section-container__participants-footer-bottom {
      background-color: #242424 !important;

      >button {
        color: white !important;
      }

      >div>button {
        color: white !important;
        border-color: white !important;
      }
    }
  }
}

#participant-window {
  flex-direction: column;

  >.window-content {
    flex: 1;
  }
}

// Change langugae
[aria-label~='mute']  {
  & .zm-modal-body-title{
    font-size: 0 !important;
    &::after{
      content: '現在の参加者と新しい参加者をミュートする';
      font-size: 24px;
    }
  }
  & .zm-checkbox-message{
    font-size: 0 !important;
    &::after{
      content: '参加者が自身の機器の音声をミュート解除することを許可';
      font-size: 13px;
    }
  }
}
</style>
